function [fval grad] = obj(mu, W, K, a, b, choiceModel)
    % Compute the objective function value in term of W
      
%     if (nargout == 1)
%         I = find(a+b~=0);
%         a = a(I);
%         b = b(I);
%         d = squareform(pdist((W*K)'));
%         d = d(I);
%         [p logP] = feval(choiceModel, d);
%         fval =  mu * norm(W,'fro')^2 - sum(a.* logP + b.*log(1 - p));
%     else
%         [I J] = find(a+b~=0);
%         fval = mu * norm(W,'fro')^2;
%         grad = 2 * mu * W;
%         for idx = 1 : length(I)
%             i = I(idx);
%             j = J(idx);
%             [p logP gradlogP gradlog1_P] = feval(choiceModel, [], W, K(:, i),  K(:, j));
%             fval = fval - (a(i,j) * logP + b(i,j) * log(1-p));
%             grad = grad - (a(i,j) * gradlogP + b(i,j) * gradlog1_P);
%         end
%     end
%     
    if (nargout == 1)
        I = find(a+b~=0);
        a = a(I);
        b = b(I);
        d = squareform(pdist((W*K)'));
        d = d(I);
        [p logP] = feval(choiceModel, d);
        fval =  mu * trace(W * K * W') - sum(a.* logP + b.*log(1 - p));
    else
        [I J] = find(a+b~=0);
        fval = mu * norm(W,'fro')^2;
        grad = 2 * mu * W * K;
        for idx = 1 : length(I)
            i = I(idx);
            j = J(idx);
            [p logP gradlogP gradlog1_P] = feval(choiceModel, [], W, K(:, i),  K(:, j));
            fval = fval - (a(i,j) * logP + b(i,j) * log(1-p));
            grad = grad - (a(i,j) * gradlogP + b(i,j) * gradlog1_P);
        end
    end
  
