function [fval grad] = obj_inverse(W, X, x, y, kernel)
    % Compute the inverse mapping objective function value in term of x
    
    K = Kx(X, x, kernel);
    yt = W * K;
    fval = (yt - 2*y)' * yt;
    if (nargout > 1)
        [d_r n] = size(X);
        K_x_prime = -(repmat(x', n, 1) - X') .* repmat(K, 1, d_r)/kernel.sigma.^2  ;
        grad = 2 * (W * K - y)' * W * K_x_prime;
    end
    